include IntelliJ::API

module IntelliJ
  module Plugins
    def self.included(base)
      base.extend self
    end

    def get_default_source(name, edition, update)
      plugin = find_plugin(name, edition)
      get_download_link(plugin, update)
    end

    def find_plugin(name, edition)
      suggestions = suggest_plugin(name, edition)
      Chef::Application.fatal!("The plugin #{name} for #{edition} edition could not be found! Similar plugins: #{suggestions.keys}", 42) unless suggestions[name]
      suggestions[name]
    end

    def get_download_link(plugin, update)
      updates = plugin_updates(plugin['id'], plugin['family'])
      update ||= updates.keys[0]
      Chef::Application.fatal!("The plugin #{plugin['name']} does not have update #{update}! Possible updates: #{updates.keys}", 42) unless updates[update.to_i]
      updates[update.to_i]
    end
  end
end
