module IntelliJ
  module Workspace
    module RunConfiguration
      def self.included(base)
        base.extend self
      end

      def generate_run_config_xml(name, type, factory, folder, body)
        attributes = {
          name: name,
          type: type,
          factory: factory,
        }
        attributes['folderName'] = folder if folder
        attrs = attributes.map { |k, v| "#{k}=\"#{v}\"" }.join(' ')

        <<-EOH
          <configuration #{attrs}>
            #{body}
          </configuration>
        EOH
      end
    end
  end
end
